;Welcome to the Mogsoft Lookup Table Example Program!
;If you are not planning on compiling this, go to EDIT and select WORD WRAP!
;In this source code, you will discover one of the coolest, yet often overlooked (by newbies at least :) features of ASM: Lookup Tables!
;I wish to thank all the fans of Mogsoft's Secret Button for making me motivated enough to write this! :)
;A more detailed explanation of lookup tables follows the tutorial, in case you still don't get it. :)
;
;*MOGSOFT, INC. IS NOT RESPONSIBLE FOR ANY HARM THAT MAY COME ABOUT FROM
;POSSIBLE INACCURATE INFORMATION THAT MAY BE CONTAINED HEREIN. MOGSOFT IS
;ALSO NOT RESPONSIBLE FOR ANY HARM THAT THIS PROGRAM MAY DO TO ANY PHYSICAL
;OR INTELLECTUAL PROPERTY, OR ANY MENTAL PSYCHOSIS, DISCOMFORT, INSANITY, OR
;ANY OTHER MENTAL DISEASE THAT MAY ARISE FROM USE OF THIS PROGRAM. YOU MAY
;MODIFY THIS PROGRAM FOR PERSONAL PURPOSES, BUT IF YOU DISTRIBUTE THEM
;PUBLICALLY, YOU *MUST* E-MAIL A COPY OF THE PROGRAM AND SOURCE TO
;ZEROMUSMOG@AOL.COM. I WANT TO SEE WHAT YOU DID WITH IT! :)*
;
;Feel free to change the messages found in Message1-Message9 and recompile
;the program. (Just remember that if you distribute it, send me a copy! :)
;Also- can you make this program expand to more or different buttons?


 include "tios.h"
 include "util.h"
 xdef _main
 xdef _comment
 xdef _ti89

;Some of the comments in Mogsoft's Secret Button about the WriteStr
;(now disp) macro were incomplete. I am now redeeming myself. These
;comments are fixed. :)

Disp macro        ;A macro. This does not save bytes. Every time this macro is called, it is included in the program again.
 move.w \3,-(a7)  ;Set the font to display the words in. Can be white on black, black on white, "xor" (inversed), and some other stuff. This is loaded to the stack.
 pea \4(pc)       ;Point to the string to display
 move.w \2,-(a7)  ;Load (push) the vertical coordinate to the stack
 move.w \1,-(a7)  ;Load (push) the horizontal coordinate to the stack
 jsr tios::DrawStrXY  ;call tios and put the string on the screen
 lea 10(a7),a7    ;Fix the stack pointer. This gets rid of the junk pushed earlier. Since 10 bytes are pushed to the stack (font(2)+pointer(4)+xcoord(2)+ycoord(2)=10), 10 is added to the stack pointer, as it goes backwards when stuff is pushed to it.
 endm             ;End the macro.

_main:
 jsr util::clr_scr          ;Clear the screen
 Disp #1,#1,#1,MessageA     ;Display MessageA, B, C, and D
 Disp #1,#9,#1,MessageB     ;(See Mogsoft's Secret Button if this is not
 Disp #1,#18,#1,MessageC    ;clear)
 Disp #1,#27,#1,MessageD
 Disp #1,#40,#1,MessageF    ;(If you're wondering why I skipped E, it's because I added this later. :)
 jsr util::idle_loop        ;Wait for keypress, then record.
 cmp #264,d0                ;Is it the ESC key?
 beq _quit                  ;If so, go to quit!
 sub.l #49,d0               ;Subtract 49 from d0. Why? 49 is the number that corresponds to the 1 key. If we do it this way, when 1 is pressed, we find the first element of the lookup table. Confused? Keep reading.
 cmp.l #0,d0                ;If a key with a value less that 49 is pressed...
 blt _main                  ;Go back to the main!
 cmp.l #9,d0                ;Is it greater than 57? (49+8)
 bgt _main                  ;If so, go back to the top!
 jsr util::clr_scr          ;Everything's OK! Clear the screen!
 rol #2,d0                  ;Multiply D0 by 4. Why, you ask? If you notice, the lookup table at the bottom is a longword. That means that each piece of data in the table takes up 4 bytes. What we're doing here is taking the address of the lookup table, then adding as many bytes as we need to get where we want.
                            ;You may also wonder why I use rol instead of mulu. Mulu is slower. However, rotating someting left can only multiply by 2, 4, 8, 16, 32, etc. More on this at the bottom.
 add.l #(MessageTable),d0   ;Add up the d0 and the message table
 move.l d0,a0               ;Copy d0 to a0, as d0 cannot point to an address!

 move.w #1,-(a7)            ;Because I am trying to find what a0 is POINTING
 move.l (a0),-(a7)          ;TO, I cannot use the regular macro. Every time
 move.w #1,-(a7)            ;I use DISP, this kind of thing is put in here.
 move.w #1,-(a7)            ;
 jsr tios::DrawStrXY        ;
 lea 10(a7),a7              ;

 Disp #1,#9,#1,MessageE     ;Display ANY KEY message
 jsr util::idle_loop        ;Wait for a keypress...
 jsr util::clr_scr          ;Clear the screen! (I hope that you know what this is by now, if you don't, please send $100 to Mogsoft, Inc. for a sackcloth and ashes kit!)*
 jmp _main

_quit:                      ;<sarcasm>Hrmn. Wonder what this does. Gee. I don't know.</sarcasm>
 rts

_comment: dc.b "Mogsoft Lookup Table Example v1.0",0

MessageA: dc.b "Press a button from 1-9 to",0
MessageB: dc.b "see a message. Make sure",0
MessageC: dc.b "ALPHA, CAPS, SHIFT etc.",0
MessageD: dc.b "are all off!",0
MessageE: dc.b "Press ANY KEY...",0
MessageF: dc.b "Press ESC to quit!",0

Message1: dc.b "Mogsoft rules!",0
Message2: dc.b "Sailor Moon!",0
Message3: dc.b "Konichiwa!",0
Message4: dc.b "I like cheese...",0
Message5: dc.b "Dilbert is funny!",0
Message6: dc.b "Assembly is easy... sorta.",0
Message7: dc.b "Best TI85 game: Galaxian!",0
Message8: dc.b "Miles Raymond!",0
Message9: dc.b "You will obey Mogsoft! :)",0

MessageTable: dc.l Message1,Message2,Message3,Message4,Message5,Message6,Message7,Message8,Message9

 end

;More Comments!
;*Special thanks to BayWare, Inc. for that joke. It comes from Power Japanese. Great program! Try it!
;BIG FAT THANKS to Dux Gregis for helping me with that #$^@#% 'Undefined Symble: 'a0'' error. Thanx a bunch! I guess this is one less tutorial he has to write! :)
;
;More About Lookup Tables:
;Lookup tables are one of those concepts that are INCREDIBLY simple and basic,
;yet extremely difficult to describe. No idea why. If you find yourself
;completely confused, you're probably thinking too hard. It's really not that
;difficult of a concept. Honest!
;(If this seems like a long description, that is because I am being thurough
;and making sure that nothing is left out. If it is too wordy or hard to
;understand, please e-mail ZeromusMog@aol.com with the part that you found
;especially confusing and I'll see what I can do about it. :)
;
;As you can see in the above code, there is a label called 'MessageTable'
;that is a longword list of other labels. In memory, these are stored as
;a list of addresses. (If you do not understand exactly how labels work
;and still think they're just magical devices that can be magically jumped
;to, please ask someone how they are really stored in memory. If you do not
;understand this, this explanation will make NO SENSE! :)
;In this program, we had nine messages that are displayed depending on what
;key is pressed. In case you didn't know, when the key '1' is pressed without
;any modifications (2nd, <>, Shift, Alpha), util::idle_loop returns the
;number '49' in register d0. 
;After the program checks to make sure that, indeed, a key between
;1 and 9 is pressed, it will look up the string to be displayed. How, you ask?
;Quite simple, really! First of all, d0 must be multiplied by 4. Since
;the mulu opcode is rather slow, I shift the register contents to the left
;by 2. (If you do not understand why, write a binary number, add 2 zeroes
;to the end, then compare the origonal number to your new one. Repeat this
;until you figure out the pattern. :) Why multiply it by 4? This is because
;each memory location stored in the pattern table is a longword, which, as
;you SHOULD know, is 4 bytes long. (Hence the dc.l! :)
;After the number is multiplied by 4, it is added to whatever number is the
;beginning of the lookup table. Since the compiler takes care of this
;busywork, you'll have to think of this number as an undefined variable.
;
;For example, here is our table:
;    ThingTable: dc.l Thing1, Thing2, Thing3, Thing4
;
;Let's say that the user presses the button '2' to display thing 2. First of
;all, idle_loop stores the value '50' into d0. Then, 49 (the value of key 1)
;is subtracted to make d0 now equal to 1. Since we are doing addresses, it
;is rotated to the left twice (multiplied by 4) to make d0 now equal 4. This
;is now how many bytes we have to move in order to get from one label to the
;other.
;    ThingTable: dc.l Thing1, Thing2, Thing3, Thing4
;...........bytes......1234....1234....1234....1234
;
;Since using undefined variables is confusing, let's say that ThingTable
;is stored at $10000000. The first four bytes of the table is occupied by
;the memory location of Thing1 ($10000000~$10000003). Thing 2 is stored in
;$10000004~$10000007. When we add up the memory location of ThingTable and
;the result we got from d0, we will now be pointing to $10000004. If we take
;what $10000004 points to, we have the data we are looking for!
;So, if we were to:
; add.l #(ThingTable),d0
; do_something_macro (d0)
;
;Whatever do_something_macro does, it can now use the data that d0 points to.
;It is, however, likely that you will need to copy the data to an address
;register so that you can use it as a memory pointer.
;
;*IMPORTANT NOTE* Remember that the first element in a lookup table is ZERO!
;This is because when you add something to the value of a lookup table, you
;are moving along the table, like a car going on a road. If you are looking
;for the first element, you don't have to go anywhere!
;
;In what other ways are lookup tables useful? One word: tilemaps.
;Possibly my next program will be about this, and tilemaps work by having
;a matrix of numbers that correspond to a sprite to use. Each element of the
;screen is read, and the program looks up each number on a lookup table.
;Herein is the BEST part of lookup tables: no matter how many sprites you
;have, your program will NOT slow down! The worst part of the 'newbie method'
;for finding data is that it uses two of the slowest opcodes to find anything:
;check and jump. (For those of you not familiar with the 'newbie method', it's
;doing:
; cmp.l #1,d0
; beq _label1
; cmp.l #2,d0
; beq _label2
; ...
;and so on and so on and so on. It's VERY inefficient!)
;
;Another popular use of lookup tables is as jump tables. These are most often
;used for menus. However, I have only done jump tables in Z80, so I am not
;sure of the exact method of doing these in 68k. Basically, you use the same
;method shown above, then you 'jmp (a0)'. Once again, much faster, smaller,
;and more efficient than the 'newbie' or 'check/jump' method.
;
;Now, if I go crazy on someone who uses the newbie method and jump on them
;like the thought police, you see why? :) It's an incredible waste of
;t-states and memory!
;
;
;If this explanation completely baffled you, please email ZeromusMog@aol.com
;and tell me what part was especially confusing! This was designed to explain
;lookup tables to people with only minimal ASM knowledge, so if it is over
;your head... I'm doing something wrong!